local tween = require "lib.tween"

local lg = love.graphics

local function Enemy(enemyType)
    self = {}
    self.w = 15
    self.h = 15
    self.color = {255, 0, 0}
    self.position = {
        x = lg.getWidth() + 5,
        y = lg.getHeight() / 2
    }
    --[[
    self.goal = {
        x = -5,
        y = lg.getHeight() / 2
    }
    self.tween = tween.new(8, self.position, self.goal, tween.easing.outBack)
    --]]

    --local tween1 = tween.new(8, self.position, {x = -5, y = lg.getHeight() / 2}, tween.easing.outBack)
    --local currentTween = tween1
    local currentTween = tween.new(3.5, self.position, {x = lg.getWidth() / 2, y = lg.getHeight() / 2}, tween.easing.outBack)
    local tweens = {}
    tweens[1] = {2, self.position, {x = lg.getWidth() * 3/4, y = lg.getHeight() * 1/4}, tween.easing.inBack}--tween.new(2, self.position, {x = lg.getWidth() * 3/4, y = lg.getHeight() * 1/4}, tween.easing.inBack)
    self.tween = {}
    self.tween.update = function(self, dt)
        if currentTween then
            if currentTween:update(dt) then
                local shit = table.remove(tweens, #tweens)
                if shit then currentTween = tween.new(shit[1], shit[2], shit[3], shit[4]) end
            end
        else
            return true
        end
    end

    return self
end

local enemies = {}

table.insert(enemies, Enemy())

function love.update(dt)
    for i=1,#enemies do
        if enemies[i].tween then
            if enemies[i].tween:update(dt) then
                enemies[i].tween = nil
                print("Success")
            end
        end
    end
end

function love.draw()
    for i=1,#enemies do
        lg.setColor(enemies[i].color)
        lg.rectangle("fill", enemies[i].position.x - enemies[i].w / 2, enemies[i].position.y - enemies[i].h / 2, enemies[i].w, enemies[i].h)
    end
end

function love.keypressed(key, unicode)
    if key == 'escape' then
        love.event.quit()
    end
end
